#include <sys/types.h>
#include <stdio.h>
#include <mysql/mysql.h>
#include <gtk/gtk.h>
#include <list.h>

struct db_result {
	MYSQL_RES *res;
};

struct db_handle {
	MYSQL *dbh;
	struct db_result res;
};

struct db_handle *db_connect(){
	struct db_handle *db;

	db = alloc_structure(struct db_handle);
	db->dbh = mysql_init(NULL);
	if (!db->dbh){
		fprintf(stderr,"mysql_init() failed.\n");
		return NULL;
	}

	mysql_options(db->dbh,MYSQL_READ_DEFAULT_GROUP,"photogui");

	if (!mysql_real_connect(db->dbh,"foo.netnation.com","wwwdata","<password>","chris_sim",0,NULL,0)){ 
		fprintf(stderr,"Failed to connect to database: %s\n",
		mysql_error(db->dbh));
		return NULL;
	}

	return db;
}

void db_disconnect(struct db_handle *db){
	mysql_close(db->dbh);
	free(db);
}

int db_query(struct db_handle *db,char *query){
	int r;

	fprintf(stderr,"Query: [%s]\n",query);
	r = mysql_real_query(db->dbh,query,strlen(query));
	if (r != 0){
		fprintf(stderr,"Failed to prepare DB query \"%s\": %s\n",
			query,mysql_error(db->dbh));
	}
	return r;
}

struct db_result *db_store_result(struct db_handle *db){
	db->res.res = mysql_store_result(db->dbh);
	if (db->res.res == NULL){
		fprintf(stderr,"Failed to store query results: %s\n",
			mysql_error(db->dbh));
	}
	return &db->res;
}

struct db_result *db_use_result(struct db_handle *db){
	db->res.res = mysql_use_result(db->dbh);
	if (db->res.res == NULL){
		fprintf(stderr,"Failed to use query results: %s\n",
			mysql_error(db->dbh));
	}
	return &db->res;
}

void db_free_result(struct db_result *res){
	mysql_free_result(res->res);
}

char **db_fetch_row(struct db_result *res){
	return mysql_fetch_row(res->res);
}

